<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ResourceLocator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.resources</a> &gt; <span class="el_source">ResourceLocator.java</span></div><h1>ResourceLocator.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.resources;

import io.gitlab.littlesaints.protean.configuration.Configuration;

import java.util.Optional;

/**
 * It's used to lookup named resources.
 * Applications can define their functions in a repository of their choice (e.g. Spring) and define a corresponding ResourceLocator to facilitate their lookup.
 * These functions can be defined in a supported format loaded using the {@link Configuration}'s loadXX methods.
 */
public interface ResourceLocator {

	/**
	 * The repository of all available implementations.
	 */
<span class="fc" id="L37">	Registry&lt;ResourceLocator&gt; REGISTRY = new Registry&lt;&gt;();</span>

	/**
	 * Lookup a resource by it's name
	 *
	 * @param name the name of the resource to lookup
	 * @param &lt;T&gt;  the getType of resource
	 * @return the resource, if available, or &lt;i&gt;null&lt;/i&gt; otherwise
	 */
	default &lt;T&gt; Optional&lt;T&gt; lookup(String name) {
<span class="fc bfc" id="L47" title="All 2 branches covered.">		if (name == null) {</span>
<span class="fc" id="L48">			return Optional.empty();</span>
		}
<span class="fc" id="L50">		return doLookup(name);</span>
	}

	&lt;T&gt; Optional&lt;T&gt; doLookup(String name);

	default &lt;T&gt; T lookupOrThrow(String name, String type) {
<span class="fc" id="L56">		Optional&lt;T&gt; resourceRef = lookup(name);</span>
<span class="pc" id="L57">		return resourceRef.orElseThrow(() -&gt; new RuntimeException(&quot;Unable to lookup &quot; + type + &quot; newInstance name &quot; + name + &quot; !!&quot;));</span>
	}

	default &lt;T&gt; Optional&lt;T&gt; optionalLookupOrThrow(String name, String type) {
<span class="fc bfc" id="L61" title="All 2 branches covered.">		if (name == null) {</span>
<span class="fc" id="L62">			return Optional.empty();</span>
		}
<span class="fc" id="L64">		return Optional.of(lookupOrThrow(name, type));</span>
	}

	default &lt;T&gt; T lookup(String name, T defaultValue) {
<span class="nc" id="L68">		Optional&lt;T&gt; op = lookup(name);</span>
<span class="nc" id="L69">		return op.orElse(defaultValue);</span>
	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>